﻿Imports System.Drawing
Namespace Css
    Public Class CssManager
        Private _files As Dictionary(Of CssFileType, CssFile)
        Public Sub New()
            _files = New Dictionary(Of CssFileType, CssFile)
            _files.Add(CssFileType.Containers, New CssFile("Containers.css"))
            _files.Add(CssFileType.Grids, New CssFile("Grids.css"))
            _files.Add(CssFileType.Menus, New CssFile("Menus.css"))
            _files.Add(CssFileType.Skin, New CssFile("Skin.css"))
            _files.Add(CssFileType.SkinLayout, New CssFile("SkinLayout.css"))
        End Sub
        Friend ReadOnly Property Files() As Dictionary(Of CssFileType, CssFile)
            Get
                Return _files
            End Get
        End Property
        Public Sub SaveCss()
            For Each f As CssFile In _files.Values
                f.Save()
            Next
        End Sub
        Public Sub ResetImages(Path As String)
            For Each f As CssFile In _files.Values
                f.ReplaceImages(Path)
            Next
        End Sub
    End Class
End Namespace